svn commit: r306419 - releng/11.0/usr.sbin/portsnap/portsnap
Ed Maste
emaste at FreeBSD.org
Wed Sep 28 22:04:08 UTC 2016
Author: emaste
Date: Wed Sep 28 22:04:07 2016
New Revision: 306419
URL: https://svnweb.freebsd.org/changeset/base/306419
Log:
MFS r306418: portsnap: only move expected snapshot contents from snap/ to files/
Previously it was possible to smuggle in addional files that would
be used by later portsnap runs. Now we only move those files expected
to be in the snapshot into files/ and require that there are no
unexpected files.
This was used by portsnap attacks 2, 3, and 4 in the "non-cryptanalytic
attacks against FreeBSD update components" anonymous gist.
Approved by: re (gjb)
Modified:
releng/11.0/usr.sbin/portsnap/portsnap/portsnap.sh
Directory Properties:
releng/11.0/ (props changed)
Modified: releng/11.0/usr.sbin/portsnap/portsnap/portsnap.sh
==============================================================================
--- releng/11.0/usr.sbin/portsnap/portsnap/portsnap.sh Wed Sep 28 21:33:35 2016 (r306418)
+++ releng/11.0/usr.sbin/portsnap/portsnap/portsnap.sh Wed Sep 28 22:04:07 2016 (r306419)
@@ -691,6 +691,13 @@ fetch_snapshot() {
fetch_index_sanity || return 1
# Verify the snapshot contents
cut -f 2 -d '|' INDEX.new | fetch_snapshot_verify || return 1
+ cut -f 2 -d '|' tINDEX.new INDEX.new | sort -u > files.expected
+ find snap -mindepth 1 | sed -E 's^snap/(.*)\.gz^\1^' | sort > files.snap
+ if ! cmp -s files.expected files.snap; then
+ echo "unexpected files in snapshot."
+ return 1
+ fi
+ rm files.expected files.snap
echo "done."
# Move files into their proper locations
More information about the svn-src-releng
mailing list